// Dragons --- My submission to the 1999 IRTC round Imaginary worlds or someting like that
// (C) Juha Leppl 1999 --- Have fun figurin' it out
// P.S Bad jokes not intended, blame my lack of sleep


#include "jd-drag.inc"

// Main console (Don't touch the red button!)
#declare Sky=on;
#declare Stars=on;
#declare Water=on;
#declare Reeds=on;
#declare Trees=on;
#declare Dragons=off;
#declare Fireball=on;
#declare Red_Button=off;

// Povak 500C POV-Color
camera {
  location <-80,17,-90>
  look_at <-62,70,80>
  angle 70
}

#if (Stars=on) // Starfield using the Galaxy includefile (by the honourable Mr. Colefax)
  #declare star_count=1500;
  #declare star_distribution=1.5;
  #declare star_brightness_turb=0.7;
  #declare star_scale=0.5;
  #declare star_color=1;
  #include "galaxy.sf" 
#end

// Sky (barely noticable)
#if (Sky=on)
  sphere {
    <0,0,0>,1
    pigment {
      gradient y
      color_map {
        [0 color rgbft <0.4,0.39,0.2,0.03,0.01>]
        [0.1 color rgbft <0.3,0.1,0.14,0.05,0.05>]      
        [0.37 color rgbft <0.05,0.02,0.026,0.1,0.5>]
        [1 color rgbft <0,0,0,0,1>]
      }
    }
    finish { diffuse 0 ambient 1 }
    hollow
    scale 10000
  }
#else
  background { color rgb <0.3,0.5,0.8> }
#end

// Just your regular light, comes in 3 flavours: cherry, vanilla and peanutbutter (eh?)
light_source { <120000,149000,180000> color rgb <0.98,0.98,1>*1.5 fade_power 1 fade_distance 100000 }
light_source { <-80,17,-90> color rgb <0.5,0.49,0.3>*0.8 fade_power 2 fade_distance 30 area_light <-.1,0,-.1>,<.1,0,.1>,3,3 adaptive 1 jitter }
light_source { <-92,100,80> color rgb <0.9,0.85,0.4> fade_power 1 fade_distance 100 area_light <-.5,0,-.5>,<.5,0,.5>,4,4 adaptive 1 jitter }  

#declare HF=
height_field {
  tga "hf.tga"
  smooth
  texture {
    gradient y
    turbulence 0.001
    texture_map {
      [0 Sand]
      [0.3 Sand]
      [0.5 Grass]
      [0.7 Grass]
    } 
  }
  translate <-.5,0,-.5>
  scale <300,50,300>
}

#declare Bark=
texture {
  pigment {
    crackle
    color_map {
      [0 color rgb <0.5,0.3,0.2>]
      [1 color rgb <0.7,0.54,0.4>]
    }
  }
  normal { crackle 0.5 }
  scale <0.05,1,0.05>
}

#declare Tree_Num=15; // Number of trees, large numbers demand MUCH memory so crank it up to 200, or maybe 10-20 is enough :)
#declare Leaves=Grass
#if (Trees=on)
#include "defaults.inc"
// Trees made with Sonya Roberts includefile. I added the ';'s to it 
#declare S=seed(6107579107);
#declare i=0; #while (i<Tree_Num)
  #declare RX=-150+(200*rand(S));
  #declare RZ=150-(150*rand(S));
  #declare RY=trace( HF <RX,150,RZ> <0,-1,0> ).y-0.1;

  // Pdt_tree declarations
  #declare SD1 = seed(int(1000*(rand(S))));
  
  #declare BallJoint=False;
  #declare BaseLen=1.75+(rand(S)*4.5);
  #declare LengthInc=1.2+(rand(S)*0.3);
  #declare MinXDeg=35;
  #declare MaxXDeg=60;
  #declare MinSplits=2;
  #declare MaxSplits=4;
  #declare IncSplits=1.15;
  #declare LeafTexture=1;
  #declare BarkTexture=1;

  object { #include "trees.inc" translate <RX,RY-0.1,RZ> }  
#declare i=i+1;#end
#end


// The ground
object { HF }

#if (Water=on) //Water
plane {
  y,14.6
  pigment { color rgbft <0.2,0.2,0.2,0.2,0.8> }
  normal { bumps 0.5 turbulence 0.5 scale <4,1,1.2> }
  finish { ambient 0 diffuse 0 reflection_min 0.25 reflection_max 0.05 reflection_exponent 0.8 specular 1 roughness 0.0001 phong 0.2 phong_size 20}
  interior { 
    ior 1.33 
    media {
      intervals 10
      absorption <0.25,0.3,0.4>*0.7
      samples 1,3
      confidence 0.999
      variance 1/1000
      density {
        gradient y
        density_map {[0 color rgb 1 ]}
        color_map {[0 color rgb 0.2]}
      }
      scale 14.6
    }
  }
  hollow
}
#end

// 2 moons
sphere { 
  <103000,155000,200000>,12000 
  texture {
    pigment { bozo turbulence 0.5 omega 0.8 color_map {[0 1 color rgb <0.8,0.7,0.81> color rgb <0.3,0.25,0.3>]} scale 3000}
    normal { bozo 5 turbulence 0.5 omega 0.8 scale 3000 }
    finish { ambient 0.05 diffuse 1 brilliance 0.1 }
  }
}

sphere {
  <82000,158000,180500>,3750
  texture {
    pigment { granite color_map { [0 1 color rgb <0.6,0.43,0.32> color rgb <0.4,0.2,0.2>]}}
    finish { ambient 0 }
    scale <300,50,300>
    rotate <30,170,-80>
  }
}


// Reeds (nothing fancy)
#if (Reeds=on)
  #declare S=seed(3477343);
  #declare w=0; #while (w<500)
    #declare P=0; #while (P=0)
    #declare TX=-120+(40*rand(S));
    #declare TZ=-80+(40*rand(S));
    #declare TY=trace( HF <TX,18,TZ> <0,-1,0>).y;
    #if (TY<14.5) #declare P=1; #end
    #end
    #declare E=<TX+(-0.2+(rand(S)*0.4)),17.5-(rand(S)*2),TZ+(-0.2+(rand(S)*0.4))>;
    #declare Dir=vnormalize(E-<TX,TY,TZ>);
    cylinder { <TX,TY,TZ>,E,0.03 pigment {color rgb <0.85,0.8,0.4>}}
    union {
      #declare E2=E+Dir+(Dir*0.8*rand(S));
      sphere { E,0.078}
      cylinder { E,E2,0.078 }
      sphere { E2,0.078 }
      texture {
        pigment {
          bozo turbulence 0.1
          color_map { [0 0.75 color rgb <0.9,0.89,0.7> color rgb <0.9,0.89,0.7>][1 color rgb <0.5,0.4,0.2>]}
          scale 0.005
        }
        normal { granite 0.5 scale <0.2,3,0.2> }
      }
    }
  #declare w=w+1; #end
#end

// A few rocks
#declare S=seed(1699375);
#declare RX=-65;
#declare RZ=-57;
#declare RYm=trace(HF <RX,20,RZ> <0,-1,0>).y;
#declare RYs=trace(HF <RX,20,RZ-1> <0,-1,0>).y;
#declare RYe=trace(HF <RX+1,20,RZ> <0,-1,0>).y;
#declare RYn=trace(HF <RX,20,RZ+1> <0,-1,0>).y;
#declare RYw=trace(HF <RX-1,20,RZ> <0,-1,0>).y;
#declare RYa=RYm-((RYs+RYe+RYn+RYw)/4);
#declare RY=RYm-(2.5*RYa);
blob {
  threshold 0.5
  #declare rl=0; #while(rl<20)
    sphere { <-1.5+(rand(S)*3),rand(S)*3,-1.5+(rand(S)*3)>,rand(S)*2.25,1 }
  #declare rl=rl+1; #end
  texture { Rock }
  translate <RX,RY,RZ>
}
#declare RX=-64;
#declare RZ=-62;
#declare RYm=trace(HF <RX,20,RZ> <0,-1,0>).y;
#declare RYs=trace(HF <RX,20,RZ-1> <0,-1,0>).y;
#declare RYe=trace(HF <RX+1,20,RZ> <0,-1,0>).y;
#declare RYn=trace(HF <RX,20,RZ+1> <0,-1,0>).y;
#declare RYw=trace(HF <RX-1,20,RZ> <0,-1,0>).y;
#declare RYa=RYm-((RYs+RYe+RYn+RYw)/4);
#declare RY=RYm-(2.5*RYa);
blob {
  threshold 0.5
  #declare rl=0; #while(rl<40)
    sphere { <-1.75+(rand(S)*3.25),rand(S)*2-0.5,-2+(rand(S)*4)>,0.3+rand(S)*2,1 }
  #declare rl=rl+1; #end
  texture { Rock }
  translate <RX,RY,RZ>
}


// Dragons, made them with sPatch. Can't live without it
#if (Dragons=on)
  #include "dragon.inc" // The mama dragon
  object { Dragon1 rotate x*33 rotate y*105 scale 9 translate <-155,137,80>}
  #include "dragon2.inc" // The dead baby dragon
  object { Dragon2 rotate y*-92 rotate -x*5.5 scale 4 translate <-67.5,trace(HF <-67.5,30,-41.8> <0,-1,0>).y+(0.526*4),-41.8> }
#end



// Ball of fire 
#if (Fireball=on)
sphere { 
  <0,0,0>,6 
  pigment { color rgbt 1 }
  interior {
    media {
      intervals 40
      samples 3,6
      emission 1
      confidence 0.99999
      variance 1/600
      density {
        spherical
        density_map {
          [0 color rgb 0]
          [0.3 color rgb 0.1]
          [1 color rgb 1]
        }
        scale 4.99
      }
      density {
        bozo
        density_map {
          [0 color rgb 0]
          [0.7 color rgb 0.01]
          [1 color rgb 1]
        }
        scale 0.5
        warp { turbulence 0.6 omega 0.8 }
        color_map {
          [0 color rgb <0.05,0,0>]
          [0.1 color rgb <0.5,0,0>]
          [1 color rgb <1,1,0>]
        }
      }
    }
  }        
  hollow
  translate <-92,100,80>
}
#declare a=137-100;
#declare b=-155-(-92);
#declare A=a/b;
#declare Angle=tan(A);
difference {
  sphere { 
    <0,0,0>, 4
    scale <7,1,1>
  }
  plane { -x,0 }
  pigment { color rgbt 1}
  interior {
    media {
      intervals 30
      samples 3,6
      emission 0.5
      confidence 0.9999
      variance 1/800
      density {
        spherical
        density_map {
          [0 color rgb 0.01]
          [0.2 color rgb 0.1]
          [1 color rgb 1]
        }
        color_map {
          [0 color rgb <0.01,0,0>]
          [0.2 color rgb <0.5,0,0>]
          [1 color rgb <1,1,0>]
        }
        scale 4
        scale <7,1,1>
      }
      density {
        bozo
        density_map {
          [0 color rgb 0]
          [0.5 color rgb 0.2]
          [1 color rgb 1]
        }
        scale 0.5
        warp { black_hole <-92,100,76>,40 }
      }
    }
  }
  hollow    
  rotate z*(Angle/(pi/180))
  translate <-92,100,80>
}    

#end

// The infamous Red button --- yikes
#if (Red_Button=on)
  #debug "\nWARNING!\a\nRed button pushed... self-destruct in 5\n4\n3\n3\n2\n1\n0\nKa-PoV!"
  #debug "\nSo you pushed the red button even when I clearly stated no to do so... \nYou think the button's here for your pleasure?"
#end

// End of file
